﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Saliavustaja.Entiteetit;
using Saliavustaja.Rajapinnat;
using Saliavustaja.TietokantaLiittymat;

namespace ravintolaprojekti
{
    public partial class UusiTilaus : Form
    {
        Tilaus tilaus = new Tilaus();
        TilausDb tilausDb = new FileSystemTilausDb("C:\\Temp\\tietokanta.dat");
        PoytaDb poytaDb = new InMemoryPoytaDb();
        AteriaDb ateriaDb = new InMemoryAteriaDb();
        BonusAsiakasDb asiakasDb = new InMemoryBonusAsiakasDb();
        
        public double ALV = 0.24;


        public UusiTilaus()
        {
            InitializeComponent();
            LisaaPoydatPudotusvalikkoon();
            LisaaAteriatListaValikkoon();

            verotonHintaLabel.Text = "";
            veronOsuusLabel.Text = "";
            tilauksenHintaLabel.Text = "";
        }

        void LisaaPoydatPudotusvalikkoon()
        {
            List<Saliavustaja.Entiteetit.Poyta> poydat = poytaDb.HaeKaikki();
            foreach (Saliavustaja.Entiteetit.Poyta poyta in poydat)
            {
                comboBox1.Items.Add(poyta);
            }
        }

        void LisaaAteriatListaValikkoon()
        {
            List<Ateria> ateriat = ateriaDb.HaeKaikki();
            foreach (var ateria in ateriat)
            {
                //luodaan listviewiin rivi
                ListViewItem rivi = new ListViewItem(ateria.Nimi);
                rivi.Tag = ateria;
                rivi.SubItems.Add((ateria.VerotonHinta * (1 + ALV)).ToString("C2"));

                //lisätään listviewiin rivi
                listView1.Items.Add(rivi);

            }
        }
        private void Tilaus_Load(object sender, EventArgs e)
        {

        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        //Lisää-nappi
        private void button1_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < listView1.SelectedItems.Count; i++)
            {
                Ateria ateria = (Ateria)listView1.SelectedItems[i].Tag;

                DataGridViewRow rivi = new DataGridViewRow();
                rivi.CreateCells(dataGridView1);
                rivi.Tag = ateria;
                rivi.SetValues(ateria.Nimi, (ateria.VerotonHinta * (1 + ALV)).ToString(), 0);

                dataGridView1.Rows.Add(rivi);
                tilaus.LisaaAteria(ateria, 1);


                //asettaa labelien hinnat kohilleen jees
                hinnatKohilleen();
            }

            //Asiakas asiakas1 = new Asiakas();
            //asiakas1.LaskeHinta(25);

            //Tilaus tilaus = new Tilaus();

        }

        //poista-nappi
        private void button2_Click(object sender, EventArgs e)
        {
            foreach (DataGridViewCell solu in dataGridView1.SelectedCells)
            {
                if (solu.Selected)
                    dataGridView1.Rows.RemoveAt(solu.RowIndex);
            }

            hinnatKohilleen();

        }

        //Asettaa hinnat labeleille plussaamalla dataGridViewissä olevat hinnat yhteen
        private void hinnatKohilleen()
        {
            double sum = 0;

            for (int i = 0; i < dataGridView1.Rows.Count; i++)
            {
                sum += Convert.ToDouble(dataGridView1.Rows[i].Cells[1].Value);
            }
            verotonHintaLabel.Text = Math.Round(sum, 2).ToString() + " €";

            double sum2 = 0;
            for (int i = 0; i < dataGridView1.Rows.Count; i++)
            {
                sum2 += Convert.ToDouble(dataGridView1.Rows[i].Cells[1].Value);
            }
            double summa2 = (sum2 * (1 + ALV) - sum2);

            veronOsuusLabel.Text = Math.Round(summa2, 2).ToString() + " €";

            double summa = (sum * (1 + ALV));
            tilauksenHintaLabel.Text = (Math.Round(summa, 2)).ToString() + " €";

        }

        private void button3_Click(object sender, EventArgs e)
        {
            do
            {

                dataGridView1.SelectAll();
                foreach (DataGridViewRow rivit in dataGridView1.Rows)
                {
                    if (rivit.Selected)
                        dataGridView1.Rows.Remove(rivit);
                }
            } while (dataGridView1.Rows.Count > 0);
            hinnatKohilleen();
        }

        private void button5_Click(object sender, EventArgs e)
        {
            
        }

        //TEE TILAUS NAPPULA
        private void button4_Click(object sender, EventArgs e)
        {
            TilauksenVastaanotto vastaanottaja = new TilauksenVastaanotto(tilausDb, poytaDb);
            vastaanottaja.VastaanotaTilaus(tilaus);

        }
    }
}
